package de.ozgcloud.document.bescheid.smartdocuments;

import java.time.LocalDate;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.PropertyNamingStrategies;
import com.fasterxml.jackson.databind.annotation.JsonNaming;

import de.ozgcloud.document.bescheid.vorgang.Vorgang;
import lombok.Builder;
import lombok.Getter;
import lombok.ToString;

@Builder
@Getter
@JsonNaming(PropertyNamingStrategies.UpperCamelCaseStrategy.class)
@ToString
class SmartDocumentsRequest {

	@Builder.Default
	private CustomerData customerData = CustomerData.builder().build();
	@Builder.Default
	private SmartDocument smartDocument = SmartDocument.builder().build();

	@Builder
	@Getter
	static class CustomerData {
		private Vorgang vorgang;
		private BescheidData bescheid;
		private UserData userData;

		@Builder
		@Getter
		static class BescheidData {
			private LocalDate bescheidVom;
			private boolean genehmigt;
		}

		@Builder
		@Getter
		static class UserData {
			private String firstName;
			private String lastName;
			private String email;
		}
	}

	@Builder
	@Getter
	@JsonNaming(PropertyNamingStrategies.UpperCamelCaseStrategy.class)
	static class SmartDocument {

		@Builder.Default
		@JsonProperty("Selection")
		private Selection selection = Selection.builder().build();

		@Builder
		@Getter
		@JsonNaming(PropertyNamingStrategies.UpperCamelCaseStrategy.class)
		static class Selection {
			@Builder.Default
			private String templateGroup = "Kiel";
			@Builder.Default
			private String template = "Halteverbot";
		}
	}

}
