package de.ozgcloud.document.bescheid.vorgang;

import java.util.List;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import lombok.Builder;
import lombok.Getter;
import lombok.Singular;

@JsonSerialize(using = FormDataEntrySerializer.class)
public interface FormDataEntry {

	String getName();

	@JsonIgnore
	String getLabel();

	@JsonIgnore
	default boolean isSubForm() {
		return false;
	}

	@JsonIgnore
	default boolean isFormEntry() {
		return false;
	}

	@Builder
	@Getter
	static class SubForm implements FormDataEntry {

		private String name;
		@JsonIgnore
		private String label;

		@Singular
		private List<FormDataEntry> entries;

		@JsonIgnore
		@Override
		public boolean isSubForm() {
			return true;
		}
	}

	@Builder
	@Getter
	static class FormField implements FormDataEntry {

		private String name;
		@JsonIgnore
		private String label;

		private Object value;

		@JsonIgnore
		@Override
		public boolean isFormEntry() {
			return true;
		}
	}
}
