package de.ozgcloud.document.bescheid.vorgang;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import de.ozgcloud.vorgang.vorgang.GrpcFindVorgangWithEingangRequest;
import de.ozgcloud.vorgang.vorgang.VorgangServiceGrpc.VorgangServiceBlockingStub;
import io.grpc.ClientInterceptor;
import lombok.NonNull;
import net.devh.boot.grpc.client.inject.GrpcClient;

@Service("bescheid_VorgangRemoteService")
class VorgangRemoteService {

	@GrpcClient("vorgang-manager")
	private VorgangServiceBlockingStub vorgangServiceStub;
	@Autowired
	private BescheidVorgangMapper mapper;

	@Autowired
	private ClientInterceptor bescheidCallContextInterceptor;

	public Vorgang getById(@NonNull VorgangId vorgangId) {
		var request = GrpcFindVorgangWithEingangRequest.newBuilder().setId(vorgangId.toString()).build();
		var response = vorgangServiceStub
				.withInterceptors(bescheidCallContextInterceptor)
				.findVorgangWithEingang(request);

		return mapper.mapVorgang(response.getVorgangWithEingang());
	}
}
