package de.ozgcloud.document.bescheid;

import de.ozgcloud.document.common.attached_item.AttachedItemTestFactory;
import de.ozgcloud.common.binaryfile.FileId;
import de.ozgcloud.document.DocumentTestFactory;

public class GrpcBescheidWithoutDocumentTestFactory {

	public static GrpcBescheid create() {
		return createBuilder().build();
	}

	public static GrpcBescheid.Builder createBuilder() {
		return GrpcBescheid.newBuilder()
				.setId(AttachedItemTestFactory.ID)
				.setVersion(AttachedItemTestFactory.VERSION)
				.setStatus(BescheidTestFactory.STATUS.name())
				.setBeschiedenAm(BescheidTestFactory.BESCHIEDEN_AM_STR)
				.setBewilligt(BescheidTestFactory.BEWILLIGT)
				.setBescheidDocument(DocumentTestFactory.ID)
				.addAllAttachments(BescheidTestFactory.ATTACHMENTS.stream().map(FileId::toString).toList())
				.setSendBy(BescheidTestFactory.SEND_BY.name())
				.setNachrichtText(BescheidTestFactory.NACHRICHT_TEXT)
				.setNachrichtSubject(BescheidTestFactory.NACHRICHT_SUBJECT)
				.setSentInfo(GrpcSentInfoTestFactory.create());
	}
}