/*
 * Copyright (C) 2024 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.document.bescheid;

import java.time.ZonedDateTime;
import java.util.Map;

import de.ozgcloud.document.bescheid.SentInfo.SentInfoBuilder;

public class SentInfoTestFactory {

	public static final String SENT_BY = "sent-by-user";
	public static final String SENT_AT_STR = "2024-01-01T00:00:00Z";
	public static final ZonedDateTime SENT_AT = ZonedDateTime.parse(SENT_AT_STR);

	public static SentInfo create() {
		return createBuilder().build();
	}

	public static SentInfoBuilder createBuilder() {
		return SentInfo.builder()
				.sentBy(SENT_BY)
				.sentAt(SENT_AT);
	}

	public static Map<String, Object> asMap() {
		return Map.of(
				SentInfo.FIELD_SENT_BY, SentInfoTestFactory.SENT_BY,
				SentInfo.FIELD_SENT_AT, SentInfoTestFactory.SENT_AT_STR);
	}
}
