package de.ozgcloud.document.bescheid.smartdocuments;

import java.util.List;

import de.ozgcloud.document.bescheid.BescheidResponseTestFactory;
import de.ozgcloud.document.bescheid.smartdocuments.SmartDocumentsBescheidRemoteService.SmartDocumentsResponse;
import de.ozgcloud.document.bescheid.smartdocuments.SmartDocumentsBescheidRemoteService.SmartDocumentsResponse.SmartDocumentDocument;
import de.ozgcloud.document.bescheid.smartdocuments.SmartDocumentsBescheidRemoteService.SmartDocumentsResponse.SmartDocumentFile;

public class SmartDocumentsResponseTestFactory {

	static final String OUTPUT_FORMAT = "PDF";

	static SmartDocumentsResponse create() {
		return createBuilder().build();
	}

	static SmartDocumentsResponse.SmartDocumentsResponseBuilder createBuilder() {
		return SmartDocumentsResponse.builder()
				.file(List.of(SmartDocumentFile.builder()
						.filename(BescheidResponseTestFactory.BESCHEID_FILE_NAME)
						.outputFormat(OUTPUT_FORMAT)
						.document(SmartDocumentDocument.builder()
								.data(BescheidResponseTestFactory.BESCHEID_FILE)
								.build())
						.build()));
	}
}
