package de.ozgcloud.document.bescheid.vorgang;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.mapstruct.factory.Mappers;
import org.mockito.InjectMocks;

class BescheidVorgangMapperTest {

	@InjectMocks
	private final BescheidVorgangMapper mapper = Mappers.getMapper(BescheidVorgangMapper.class);

	@Nested
	class TestMapVorgang {

		@Test
		void shouldMapEingang() {
			var result = mapper.mapVorgang(GrpcVorgangWithEingangTestFactory.create());

			assertThat(result.getEingang()).isNotNull();
		}

		@Test
		void shouldMapVorgangId() {
			var result = mapper.mapVorgang(GrpcVorgangWithEingangTestFactory.create());

			assertThat(result.getId()).isEqualTo(VorgangTestFactory.ID);
		}

		@Test
		void shouldMapVersion() {
			var result = mapper.mapVorgang(GrpcVorgangWithEingangTestFactory.create());

			assertThat(result.getVersion()).isEqualTo(VorgangTestFactory.VERSION);
		}
	}
}
